//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerEmbed = {
	timerTimeout: null,
	win: null,
	titleLocale: null,
	elementMeter: null,
	elementPercent: null,
	maxProgress: null,
	meterProgress: null,
	leatestTaskPercent: 0,
	manualBackup: false,
	init: function() {
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		this.timerTimeout = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		this.win = document.getElementById("bookmarkfaviconchanger-Embed");
		this.titleLocale = this.win.getAttribute("title");
		this.elementMeter = document.getElementById("bookmarkfaviconchangerEmbedMeter");
		this.elementPercent = document.getElementById("bookmarkfaviconchangerEmbedPercent");
		this.maxProgress = bookmarkfaviconchangerModule.totalJob;
		this.elementMeter.max = this.maxProgress;
		this.meterProgress = 0;
		this.elementMeter.value = 0;
		this.elementPercent.value = "0%";
		this.win.setAttribute("title","0% "+this.titleLocale);
		this.manualBackup = bookmarkfaviconchangerModule.placesActive;
		this.timerTimeout.initWithCallback({notify:function(timer){bookmarkfaviconchangerEmbed.progress();} }
			,0,Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	},
	focus: function() {
		if (!this.manualBackup) {
			window.blur();
			this.manualBackup = true;	// blur only once
		}
	},
	noCancel: function() {
		Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound).beep();
		return false;
	},
	progress: function() {
		this.timerTimeout.cancel();
		this.meterProgress = bookmarkfaviconchangerModule.embedJsonAnnotationSlice();
		if (this.meterProgress == -1) {
			window.close();
		} else {
			this.elementMeter.value = this.meterProgress;
			var taskPercent = Math.floor(100*this.meterProgress/this.maxProgress);
			if (this.leatestTaskPercent != taskPercent) {
				this.leatestTaskPercent = taskPercent;
				this.elementPercent.value = taskPercent+"%";
				this.win.setAttribute("title",taskPercent+"% "+this.titleLocale);
			}
			this.timerTimeout.initWithCallback({notify:function(timer){bookmarkfaviconchangerEmbed.progress();} }
				,0,Components.interfaces.nsITimer.TYPE_ONE_SHOT);
		}
	}
}