//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerReload = {
	observe : function(subject, topic, data) {
		if (topic == "bookmarkfaviconchangerBroadcast") {
			if (data=="newCSS") {
				window.location.reload();
			}
		}
	},
	onload: function() {
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		bookmarkfaviconchangerModule.init();
		bookmarkfaviconchangerModule.observerService.addObserver(this, "bookmarkfaviconchangerBroadcast", false);
		window.removeEventListener("load", function(){bookmarkfaviconchangerReload.onload();}, false);
		window.addEventListener("unload", function(){bookmarkfaviconchangerReload.onunload();}, false);
	},
	onunload: function() {
		bookmarkfaviconchangerModule.observerService.removeObserver(this, "bookmarkfaviconchangerBroadcast");
		window.removeEventListener("unload", function(){bookmarkfaviconchangerReload.onunload();}, false);
	},
}
window.addEventListener("load", function(){bookmarkfaviconchangerReload.onload();}, false);