//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerTreeView = {
	getCellProperties: null,
	onload: function() {
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		bookmarkfaviconchangerModule.init();
		// extending function getCellProperties in treeview.js - Add each tree folder a unique property
		// function PTV_getCellProperties(aRow, aColumn, aProperties)
		// For Gecko 22 it change to 		// function PTV_getCellProperties(aRow, aColumn) and return whitespace delimited string
		bookmarkfaviconchangerTreeView.getCellProperties = PlacesTreeView.prototype.getCellProperties;
		PlacesTreeView.prototype.getCellProperties = function()
		{
			if (bookmarkfaviconchangerModule.geckoBefore22) {
				bookmarkfaviconchangerTreeView.getCellProperties.apply(this, arguments);
				try {
					if (arguments[1].primary) {
						if (this.isContainer(arguments[0])) {
							var bookmarkfaviconchangerItemId = this._rows[arguments[0]].itemId;
							if (bookmarkfaviconchangerModule.isUsableItemId(bookmarkfaviconchangerItemId)) {
								arguments[2].AppendElement(bookmarkfaviconchangerModule.atomService.getAtom("bookmarkfaviconchanger" + bookmarkfaviconchangerItemId));
							}
						}
					}
				} catch(e) {
				}
			} else {
				var prop = bookmarkfaviconchangerTreeView.getCellProperties.apply(this, arguments);
				try {
					if (arguments[1].primary) {
						if (this.isContainer(arguments[0])) {
							var bookmarkfaviconchangerItemId = this._rows[arguments[0]].itemId;
							if (bookmarkfaviconchangerModule.isUsableItemId(bookmarkfaviconchangerItemId)) {
								prop = prop + " bookmarkfaviconchanger" + bookmarkfaviconchangerItemId;
							}
						}
					}
				} catch(e) {
				}
				return prop;
			}
		};
		window.removeEventListener("load", function(){bookmarkfaviconchangerTreeView.onload();}, false);
		// window.addEventListener("unload", function(){bookmarkfaviconchangerTreeView.onunload();}, false);
	},
	//onunload: function() {
		// window.removeEventListener("unload", function(){bookmarkfaviconchangerTreeView.onunload();}, false);
	//},
	delayLoadEvent: function() {
		// I add load event at this to make sure that this extension will be run at the last, not before other extension
		// Because some extension use e-v-a-l to destroy my hook function (eg. faviconizetab version 1.0.4)
		// And some extension manipulate the same target as mine. (eg. CuteButtons - Crystal SVG version 0.2.9).
		// Inserting element into context menu is also important.
		// These problem can be solved if this extension run at the last. THE LAST IS THE WINNER! :D
		window.removeEventListener("DOMContentLoaded", bookmarkfaviconchangerTreeView.delayLoadEvent, false);
		window.addEventListener("load", function(){bookmarkfaviconchangerTreeView.onload();}, false);
	}
}
window.addEventListener("DOMContentLoaded", bookmarkfaviconchangerTreeView.delayLoadEvent, false);