//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerPlaces = {
	exportToFile: null,
	backupBookmarks: null,
	onactivate: function() {
		bookmarkfaviconchangerModule.placesActive = true;
	},
	ondeactivate: function() {
		bookmarkfaviconchangerModule.placesActive = false;
	},
	onload: function() {
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		bookmarkfaviconchangerModule.init();
		if ((!bookmarkfaviconchangerModule.geckoBefore23) && (bookmarkfaviconchangerModule.geckoBefore25)) {
			Components.utils.import("resource://gre/modules/PlacesBackups.jsm");
			PlacesOrganizer.backupBookmarks = function PO_backupBookmarks() {
				let dirSvc = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties);
				let backupsDir = dirSvc.get("Desk", Ci.nsILocalFile);
				let fp = Cc["@mozilla.org/filepicker;1"].createInstance(Ci.nsIFilePicker);
				let fpCallback = function fpCallback_done(aResult) {
					if (aResult != Ci.nsIFilePicker.returnCancel) {
						PlacesBackups.saveBookmarksToJSONFile(fp.file);
					}
				};
				fp.init(window, PlacesUIUtils.getString("bookmarksBackupTitle"),Ci.nsIFilePicker.modeSave);
				fp.appendFilter(PlacesUIUtils.getString("bookmarksRestoreFilterName"),PlacesUIUtils.getString("bookmarksRestoreFilterExtension"));
				fp.defaultString = PlacesBackups.getFilenameForDate();
				fp.displayDirectory = backupsDir;
				fp.open(fpCallback);
			}
		}
		window.addEventListener("activate", function(){bookmarkfaviconchangerPlaces.onactivate();}, false);
		window.addEventListener("deactivate", function(){bookmarkfaviconchangerPlaces.ondeactivate();}, false);
		window.removeEventListener("load", function(){bookmarkfaviconchangerPlaces.onload();}, false);
		window.addEventListener("unload", function(){bookmarkfaviconchangerPlaces.onunload();}, false);
	},
	onunload: function() {
		window.removeEventListener("activate", function(){bookmarkfaviconchangerPlaces.onactivate();}, false);
		window.removeEventListener("deactivate", function(){bookmarkfaviconchangerPlaces.ondeactivate();}, false);
		window.removeEventListener("unload", function(){bookmarkfaviconchangerPlaces.onunload();}, false);
	},
}
window.addEventListener("load", function(){bookmarkfaviconchangerPlaces.onload();}, false);